; Author: Falko Lnsmann
; Homepage: www.falko-pure.de
; Ansteuern von Schieberegistern von 8 und mehr digitalen Ausgngen durch Kaskadieren des IC 74595
; Die verwendeten IC's 74165 und 74595
; Zur Steuerung der LPT bentigen sie die Inpout64.dll bzw. Inpout32.dll und .SYS
; Die Schaltung kann man sich hier auf meine Webseite anschauen.

; Verwendete Signale der LPT:
; Datenregister D0-D7 = Pin 2 bis Pin 9 --> Bytewerte ausgeben 

; Steuerregister Strobe   = Pin 1    (PullUp gegen +5V) 
; Steuerregister AutoFeed = Pin 14   (PullUp gegen +5V) 
; Steuerregister Init     = Pin 16   (PullUp gegen +5V)

; Statusregister Ack      = Pin 10   (PullUp gegen +5V)  Zur Abfrage. Wird hierbei nicht bentigt!



;- Window Constants
;
Enumeration
  #Window_0
EndEnumeration

;- Gadget Constants
;
Enumeration
  #String_0
  #CheckBox_0
  #CheckBox_1
  #CheckBox_2
  #CheckBox_3
  #CheckBox_4
  #CheckBox_5
  #CheckBox_6
  #CheckBox_7
  #Button_0
  #Button_1
  #Text_0
  #Text_1
  #Text_2
  #Text_3
  #Text_4
  #Text_5
  #Text_6
  #Text_7
EndEnumeration


Global BA.w
BA=$E080; Meine zwei LPT auf PCI-Karte LPT1=E080, LPT2=E480. Standard sind LPT1=384, LPT2=E280; LPT3=3BC

Procedure Open_Window_0()
  If OpenWindow(#Window_0, 480, 355, 183, 235, "Test  74165 und 74595",  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar )
      StringGadget(#String_0, 40, 25, 90, 20, "")
      CheckBoxGadget(#CheckBox_0, 10, 90, 20, 20, "")
      CheckBoxGadget(#CheckBox_1, 30, 90, 20, 20, "")
      CheckBoxGadget(#CheckBox_2, 50, 90, 20, 20, "")
      CheckBoxGadget(#CheckBox_3, 70, 90, 20, 20, "")
      CheckBoxGadget(#CheckBox_4, 90, 90, 20, 20, "")
      CheckBoxGadget(#CheckBox_5, 110, 90, 20, 20, "")
      CheckBoxGadget(#CheckBox_6, 130, 90, 20, 20, "")
      CheckBoxGadget(#CheckBox_7, 150, 90, 20, 20, "")
      ButtonGadget(#Button_0, 30, 120, 110, 40, "Senden")
      ButtonGadget(#Button_1, 30, 180, 110, 40, "Programmende")
      TextGadget(#Text_0, 10, 70, 20, 20, "D7")
      TextGadget(#Text_1, 30, 70, 20, 20, "D6")
      TextGadget(#Text_2, 50, 70, 20, 20, "D5")
      TextGadget(#Text_3, 70, 70, 20, 20, "D4")
      TextGadget(#Text_4, 90, 70, 20, 20, "D3")
      TextGadget(#Text_5, 110, 70, 20, 20, "D2")
      TextGadget(#Text_6, 130, 70, 20, 20, "D1")
      TextGadget(#Text_7, 150, 70, 20, 20, "D0")
      
    EndIf
EndProcedure


Procedure.a GetBin(); Welche der 8 Bits wurden gesetzt?
 DOUT.a=0
 If GetGadgetState(#CheckBox_7)=1:DOUT+1:EndIf
 If GetGadgetState(#CheckBox_6)=1:DOUT+2:EndIf
 If GetGadgetState(#CheckBox_5)=1:DOUT+4:EndIf
 If GetGadgetState(#CheckBox_4)=1:DOUT+8:EndIf
 If GetGadgetState(#CheckBox_3)=1:DOUT+16:EndIf
 If GetGadgetState(#CheckBox_2)=1:DOUT+32:EndIf
 If GetGadgetState(#CheckBox_1)=1:DOUT+64:EndIf
 If GetGadgetState(#CheckBox_0)=1:DOUT+128:EndIf 
 SetGadgetText(#String_0,RSet(Bin(DOUT),8,"0")+" = "+RSet(Hex(DOUT),2,"0")+"H")  
 ProcedureReturn DOUT   
EndProcedure

If OpenLibrary(0, "inpout32.dll")
  Prototype.i ProtoIOx32_0()                ;kein Parameter
  IOx32IsOpen.ProtoIOx32_0 = GetFunction(0, "IsInpOutDriverOpen")
  Prototype.i ProtoIOx32_1(PortAdr)         ;1 Parameter
  IOx32Inp32.ProtoIOx32_1 = GetFunction(0, "Inp32")
  Prototype.i ProtoIOx32_2(PortAdr, WertB)  ;2 Parameter
  IOx32Out32.ProtoIOx32_2 = GetFunction(0, "Out32") 
;- Load Library INPOUT32
If IOx32IsOpen()
;Strobe auf H setzen
IOx32Out32(BA+2,1!11); Strobe H. Wichtig fr den 74165
Open_Window_0()
GetBin()
Repeat ; Start of the event loop
  
  Event = WaitWindowEvent() ; This line waits until an event is received from Windows
  
  WindowID = EventWindow() ; The Window where the event is generated, can be used in the gadget procedures
  
  GadgetID = EventGadget() ; Is it a gadget event?
  
  EventType = EventType() ; The event type
  
  ;You can place code here, and use the result as parameters for the procedures
  
  If Event = #PB_Event_Gadget
    
    If GadgetID = #String_0
      
    ElseIf GadgetID = #CheckBox_0
      GetBin()
    ElseIf GadgetID = #CheckBox_1
      GetBin()
    ElseIf GadgetID = #CheckBox_2
       GetBin()
    ElseIf GadgetID = #CheckBox_3
       GetBin()
    ElseIf GadgetID = #CheckBox_4
       GetBin()
    ElseIf GadgetID = #CheckBox_5
       GetBin()
    ElseIf GadgetID = #CheckBox_6
       GetBin()
    ElseIf GadgetID = #CheckBox_7
       GetBin()
    ElseIf GadgetID = #Button_0
     ;Byte-Data 
     IOx32Out32(BA,GetBin())
     ;Strobe 1-0-1
     IOx32Out32(BA+2,1!11)  ; Strobe H, Init L, AutoFeed L
     IOx32Out32(BA+2,0!11)  ; Strobe L, Init L; AutoFeed L
    ;8 Takte senden 0-1
     IOx32Out32(BA+2,3!11)  ; AutoFeed H, Strobe H, Init L
     For i= 1 To 7
      IOx32Out32(BA+2,1!11) ; AutoFeed L, Strobe H, Init L
      IOx32Out32(BA+2,3!11) ; AutoFeed H, Strobe H, Init L
     Next i
     ;Master Strobe 0-1-0   
     IOx32Out32(BA+2,1!11)  ; Init L, AutoFeed L, Strobe H  
     IOx32Out32(BA+2,5!11)  ; Init H, AutoFeed L, Strobe H
     IOx32Out32(BA+2,1!11)  ; Init L, AutoFeed L, Strobe H       
    ElseIf GadgetID = #Button_1
       Event = #PB_Event_CloseWindow
    EndIf
    
  EndIf
  
Until Event = #PB_Event_CloseWindow ; End of the event loop
EndIf
EndIf
CloseLibrary(0)
End
;

; IDE Options = PureBasic 4.40 Beta 5 (Windows - x64)
; CursorPosition = 54
; FirstLine = 46
; Folding = -
; EnableXP
; UseIcon = Falko_Pure.ico
; DisableDebugger
; HideErrorLog
; CompileSourceDirectory